{{
  Clock engine cog and bump functionality

  Note how this module depends on tdfmt to access the formatted
  time and date longs.
}}
obj

  tfmt      : "tdfmt"

var

  long TimePtr
  long DatePtr
  long stack[25]

pub Start(Tptr, Dptr)

  timeptr := tptr
  dateptr := dptr

  'initialize time and date to valid values
  long[timeptr] := 0
  long[dateptr] := $010101  'day of week, date, and month cannot be zero

  cognew(clkengine, @stack)

pri clkengine | c0, time, date, h, m, s, dw, d, mo, ml, y
{
  cog which advances the time and date each second
}
  c0 := cnt
  repeat
    waitcnt(c0 += clkfreq) 'synchronized
    '
    'this happens every second
    '
    time := long[timeptr]
    s := tfmt.second(time)
    s++
    if s > 59
      s := 0
      m := tfmt.minute(time)
      m++
      if m > 59
        m := 0
        h := tfmt.hour(time)
        h++
        if h > 23
          h := 0
          date := long[dateptr]
          dw := tfmt.day(date)
          dw++
          if dw > 7
            dw := 1
          date := tfmt.setday(date, dw)
          d := tfmt.date(date)
          mo := tfmt.month(date)
          y := tfmt.year(date)
          d++
          ml := lookup(mo: 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
          if ml == 28 and (y & %11) == 0
            ml++
          if d > ml
            d := 1
            mo++
            if mo > 12
              mo := 1
              y++
              if y > 99
                y := 0
              date := tfmt.setyear(date, y)  
            date := tfmt.setmonth(date, mo)
          date := tfmt.setdate(date, d)                    
          long[dateptr] := date
        time := tfmt.sethour(time, h)
      time := tfmt.setminute(time, m)
    time := tfmt.setsecond(time, s)
    long[timeptr] := time              
    
pub Bump(field, dir) | td, vmin, vmax, v

  case field
    0..2:
      td := long[timeptr]
    other:
      td := long[dateptr]

  vmin := 0    
  case field
    0:
      v := tfmt.second(td)
      vmax := 59
    1:
      v := tfmt.minute(td)
      vmax := 59
    2:
      v := tfmt.hour(td)
      vmax := 23
    3:
      v := tfmt.day(td)
      vmin := 1
      vmax := 7
    4:
      v := tfmt.date(td)
      vmin := 1
      vmax := lookup(tfmt.month(td): 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
      if vmax == 28 and (tfmt.year(td) & %11) == 0
        vmax++
    5:
      v := tfmt.month(td)
      vmin := 1
      vmax := 12
    6:
      v := tfmt.year(td)
      vmin := 0
      vmax := 99

  v += dir
  if v < vmin
    v := vmax
  elseif v > vmax
    v := vmin

  case field
    0:
      td := tfmt.setsecond(td, v)
    1:
      td := tfmt.setminute(td, v)
    2:
      td := tfmt.sethour(td, v)
    3:
      td := tfmt.setday(td, v)
    4:
      td := tfmt.setdate(td, v)
    5:
      td := tfmt.setmonth(td, v)
    6:
      td := tfmt.setyear(td, v)

  case field
    0..2:
      long[timeptr] := td
    other:
      long[dateptr] := td
    
          
    