{{
  Aani-Nano Self Contained Truck Weighing System
}}

CON

  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000                                            

VAR
{
  Master system time and date in two longs
}
  long  SysTime  'sec (0-59) + min (0-59) << 8 + hour (0-23) << 16  
  long  SysDate  'day (1-7) + date (1-31) << 8 + month (1-12) << 16 + year (0-99) << 24 

OBJ

  key       : "keyboard"
  vid       : "vga_text_nf"
  rtc       : "clkengine"
  sf        : "strfmt"
  tfmt      : "tdfmt"
  bkg       : "bkgtext"

PUB Main | c, s, s0, buf[12], tbuf[12], ptr, tptr

  key.start(26, 27)
  vid.start(16)
  rtc.start(@systime, @sysdate)

  drawbkg(0)
  repeat
    repeat while (c := key.key) <> 0
      case c
        "a".."z":
          'touppercase
          c -= 32  
      case c
        $CB:
          setclk
          drawbkg(0)
        "A".."H":
          'toggle bits A-H = 0..7
          tfmt.setstyle(tfmt.getstyle ^ |<(c - "A"))
      s0 := $FF 'force screen redraw
    s := tfmt.second(systime)
    if s <> s0
      'redraw when second changes
      vid.out(1)
      ptr := tfmt.timefmt(@tbuf, systime)
      ptr := sf.ch(ptr, " ")
      ptr := tfmt.datefmt(ptr, sysdate)
      'Note that a second buffer is needed to do a new formatting
      'operation on the formatted contents of another buffer
      sf.cstr(@buf, @tbuf, 32) 'center on screen
      vid.str(@buf)
      s0 := s

pri setclk | c, s, s0, edptr, edfld, buf[12]

  edptr := 1
  edfld := 2
  drawbkg(1)
  s0 := $FF
  repeat
    repeat while (c := key.key) <> 0
      case c
        "a".."z":
          c -= 32  
      case c
        $CB:
          return
        $C0:
          edptr := edptr - 1 #> 1
        $C1:
          edptr := edptr + 1 <# 7
        $C2:
          rtc.bump(edfld, 1)
        $C3:
          rtc.bump(edfld, -1)
        "A".."H":
          tfmt.setstyle(tfmt.getstyle ^ |<(c - "A"))
      if tfmt.getstyle & tfmt#st_date_ddmm
        edfld := lookup(edptr:2,1,0,3,4,5,6)
      else
        edfld := lookup(edptr:2,1,0,3,5,4,6) 
      s0 := $FF 'force screen redraw
    s := tfmt.second(systime)
    if s <> s0
      vid.str(string(1,"  "))
      'Note there is no point centering this display, since
      'there are unprinted characters for highlighting the
      'edit field which would mess up the count.  We also
      'don't need to progress a ptr since at this level it's
      'a single operation.
      tfmt.setclkfmt(@buf, systime, sysdate, edfld)
      vid.str(@buf)
      vid.str(string("        "))
      s0 := s
      
      
{
  This illustrates using a large temporary buffer to retrieve a more
  elaborate composite format.  The buffer must be large enough to
  accommodate the largest possible result.  Note that temp vars are
  always longs so buf[60] actually reserves 240 bytes.  
}
pri drawbkg(mode) | buf[60]
  vid.out(0) 'can't put this in a string
  case mode
    0:
      bkg.normal(@buf)
    1:
      bkg.setclk(@buf)
  vid.str(@buf)

  